//+------------------------------------------------------------------+
//|                                #1 BUY 25 BB by Steve Hopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  buy "Buy"
#define  sell "Sell"

/*
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool DoesTradeExist()

*/

extern double  Lot=0.01;
extern double  StopLoss=999;
extern int     MagicNumber=7;
extern string  TradeComment="#7 Buy 25.2.2";
extern bool    CriminalIsECN=true;
extern bool    UseSafetyFeature=true;
extern int     ReEntryLinePips=200;
extern color   ReEntryLineColour=Turquoise;
extern int     BarCount = 120;
extern string  tpi="----Take profit and stop loss inputs----";
extern int     TakeProfit=0;
extern bool    UseSixthsTp = false;
extern bool    UseBollingerTp = true;
extern bool    UseAtrTp=false;
extern int     AtrTpPeriod=14;
extern int     AtrTpTimeFrame=0;
extern double  AtrTpMultiplier=3;
extern int     MinimumTargetinPips = 50;

//6ths variable.
double         BottomGoldLine;//Bottom, gold line
double         BottomGreenLine;//Bottom, green line
double         MiddleWhiteLine;//Middle, white line
double         TopGreenLine;//Top, green line
double         TopGoldLine;//Top, gold line

double         BbUpper, BbLower;
bool           RobotSuspended;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----


   //Reset ReEntryLinePips according to pair volatility. My thanks to Max for thisn
   if (StringSubstr(Symbol(), 0, 6) == "AUDCAD") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "AUDCHF") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "AUDJPY") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "AUDNZD") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "AUDUSD") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "CADCHF") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "CADJPY") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "CHFJPY") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "EURAUD") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "EURCAD") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "EURCHF") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "EURGBP") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "EURJPY") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "EURNZD") { ReEntryLinePips =250;}
   if (StringSubstr(Symbol(), 0, 6) == "EURUSD") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "GBPCHF") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "GBPJPY") { ReEntryLinePips =250;}
   if (StringSubstr(Symbol(), 0, 6) == "GBPUSD") { ReEntryLinePips =200;}
   if (StringSubstr(Symbol(), 0, 6) == "NZDJPY") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "NZDUSD") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "SGDJPY") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "USDCHF") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "USDCAD") { ReEntryLinePips =150;}
   if (StringSubstr(Symbol(), 0, 6) == "USDJPY") { ReEntryLinePips =180;}
   if (StringSubstr(Symbol(), 0, 6) == "USDNOK") { ReEntryLinePips =1500;}
   if (StringSubstr(Symbol(), 0, 6) == "USDSEK") { ReEntryLinePips =1500;}

   //Accommodate different quote sizes
   double multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;
   ReEntryLinePips*= multiplier;//Copy this
   MinimumTargetinPips*= multiplier;
      
   if (UseSafetyFeature)
   {
      
      int retval = MessageBox(Symbol() + ": do you wish to continue to use this robot BUY #7 25.2.2?", "Question", MB_YESNO|MB_ICONQUESTION);
      if (retval == IDNO) RobotSuspended = true;
      else RobotSuspended = false;   
   }//if (UseSafetyFeature)
   
   if (TradeComment == "") TradeComment = " ";

//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   
//----
   return(0);
}

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   
   //if (StopTrading) return(true);
   /*
   if (!IsTesting())
   {   
      if (!IsTradeAllowed() ) return(false);
      if (!IsConnected() ) return(false);
      if (!IsExpertEnabled() ) return(false);
      if (!IsTradeContextBusy() ) return(false);
   }//if (!IsTesting)
   */
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   
   //Take profit
   if (type == OP_BUY)
   {
      if (take == 0) // if no fixed take profit, check use options for calculating take profit
      {
         take = SetTarget(buy);
      }//if (take == 0)

   }//if (type == OP_BUY)
   
   if (type == OP_SELL)
   {
      if (take == 0) // if no fixed take profit, check use options for calculating take profit
      {
         take = SetTarget(sell);
      }//if (take == 0)

   }//if (type == OP_SELL)
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
	   if (ticket > -1)
      {
         if (stop >0 && take > 0) bool result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
         //Stop loss but no take profit
         if (stop >0 && take == 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
         //Take profit but no stop loss
         if (stop ==0 && take > 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
         if (!result)
         {
             int err=GetLastError();
             Print(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)			  
      }//if (ticket > -1)
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      //Alert(Symbol(), " ", stype," Nanningbob order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," #1 Buy Nanningbob order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

bool DoesTradeExist()
{
   
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         return(true);         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()

void GetSixths()
{
   /*
   These are declared in the general section and count the lines from the bottom upwards
   double         BottomGoldLine;//Bottom, gold line
   double         BottomGreenLine;//Bottom, green line
   double         MiddleWhiteLine;//Middle, white line
   double         TopGreenLine;//Top, green line
   double         TopGoldLine;//Top, gold line

   */

   double value = High[iHighest(NULL,0,MODE_HIGH,BarCount,1)] - Low[iLowest(NULL,0,MODE_LOW,BarCount,1)];      //value top of the chart - value bottom
   double sixth = value/6;
   double valueS = (value*(MathPow(10,Digits)));
   double sixthS = (sixth*(MathPow(10,Digits)));
   
   BottomGoldLine = NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth, Digits);
   BottomGreenLine = NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth, Digits);
   MiddleWhiteLine = NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth, Digits);
   TopGreenLine = NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth+sixth, Digits);
   TopGoldLine = NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth+sixth+sixth, Digits);



}//End void GetSixths()
double SetTarget(string tradedirection)
{
   double target = 0;
   if (tradedirection == sell) // SELL
   {
      if (UseSixthsTp) // use Sixths
      { 
         if ( MathAbs(Bid-TopGreenLine) < (Point*MinimumTargetinPips) ) { target = BottomGreenLine;  }
         else { target = TopGreenLine; }
      }
      else if (UseAtrTp) // use Atr
      {
         double AtrVal = iATR(Symbol(), AtrTpTimeFrame, AtrTpPeriod, 0) * AtrTpMultiplier;
         target = NormalizeDouble(Bid - AtrVal,Digits);
      } 
      else if (UseBollingerTp) // use BollingerBands middle band
      {
         double MiddleBB = iBands(NULL, 0,  25, 2, 0, PRICE_CLOSE, MODE_MAIN, 0);
         if ( MathAbs(Bid-MiddleBB) < (Point*MinimumTargetinPips) ) 
         { target = Bid - (MinimumTargetinPips * Point); }
         else { target = MiddleBB; } 
      }
      
   }
   else if (tradedirection == buy) // BUY
   {
      if (UseSixthsTp) // use Sixths
      {
         if ( MathAbs(Ask-TopGreenLine) < (Point*MinimumTargetinPips) ) { target = TopGreenLine;  }
         else { target = TopGreenLine; }
      }
      else if (UseAtrTp) // use Atr
      {
         AtrVal = iATR(Symbol(), AtrTpTimeFrame, AtrTpPeriod, 0) * AtrTpMultiplier;
         target = NormalizeDouble(Ask + AtrVal,Digits);
      } 
      else if (UseBollingerTp) // use BollingerBands middle band
      {
         MiddleBB = iBands(NULL, 0,  25, 2, 0, PRICE_CLOSE, MODE_MAIN, 0);
         if ( MathAbs(Ask-MiddleBB) < (Point*MinimumTargetinPips) ) 
         { target = Ask + (MinimumTargetinPips * Point); }
         else { target = MiddleBB; }
      
      }
   }
   return (NormalizeDouble(target,Digits));
}//End double SetTarget(string tradedirection)


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   
   if (RobotSuspended)
   {
      Comment("......................This robot is suspended.................");
      return;
   }//if (RobotSuspended)
   
   
   if (DoesTradeExist()) return;
   if (ObjectFind("Re entry line") > -1) ObjectDelete("Re entry line");
      
   double  Var1, Var2;
   //---- indicators
   
   // MOVING AVERAGE
   Var1 = iMA(NULL, PERIOD_H4, 1, 0, MODE_LWMA, PRICE_MEDIAN, 1);
   Var2 = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_LOWER, 1); 
    
   BbLower = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_LOWER, 0); 
   BbUpper = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_UPPER, 0);
 //if( (Var1 < Var8 && Bid > Var8)|| (Var1 > Var8))
   RefreshRates();
   if (Bid > BbLower && Var1 < Var2) 
   {
      double stop = NormalizeDouble(Ask - (StopLoss * Point),Digits);
      if (StopLoss == 0) stop = 0;
      double take = NormalizeDouble(Ask + (TakeProfit * Point),Digits);
      if (TakeProfit == 0) take = 0;
      if (UseSixthsTp) GetSixths();
      bool result = SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, stop, take);
      if (result && UseSafetyFeature) 
      {
         RobotSuspended = true;
         Alert(Symbol() + " NB EA has sent a trade and suspended itself");
      }//if (result && UseSafetyFeature) 

      //Re entry line
      if (result)
      {
         double LinePrice = NormalizeDouble(Ask - (ReEntryLinePips * Point), Digits);
         ObjectCreate("Re entry line",OBJ_HLINE,0,TimeCurrent(),LinePrice);
         ObjectSet("Re entry line",OBJPROP_COLOR,ReEntryLineColour);
         ObjectSet("Re entry line",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("Re entry line",OBJPROP_WIDTH,2);     

      }//if (result)
      
   }//if(Bid < Var2 && Var1 > BbLower)
    

//----
   return(0);
}
//+------------------------------------------------------------------+